IOSTAT(8)

NAME
iostat - report I/O statistics

SYNOPSIS
iostat [-CdhIKoTxz?] [-c count] [-M core] [-n devs] [-N system] [ -t type,if,pass] [-w wait] [drives]

DESCRIPTION
The iostat utility displays kernel I/O statistics on terminal, device and cpu operations. The first statistics that are printed are averaged over the system uptime. To get information about the current activity, a suitable wait time should be specified, so that the subsequent sets of printed statistics will be averaged over that time.

The options are as follows:

-c  Repeat the display count times. If no repeat count is specified, the default depends on whether -w is specified. With -w the default repeat count is infinity, otherwise it is 1.

-C  Display CPU statistics. This is on by default, unless -d or -x is specified.

-d  Display only device statistics. If this flag is turned on, only device statistics will be displayed, unless -C or -T is also specified to enable the display of CPU or TTY statistics.

-h  Put iostat in ‘top’ mode. In this mode, iostat will show devices in order from highest to lowest bytes per measurement cycle.

-I  Display total statistics for a given time period, rather than average statistics for each second during that time period.

-K  In the blocks transferred display (-o), display block count in kilobytes rather then the device native block size.

-M  Extract values associated with the name list from the specified core instead of the default “/dev/kmem”.

-n  Display up to devs number of devices. The iostat utility will display fewer devices if there are not devs devices present.

-N  Extract the name list from the specified system instead of the default “/boot/kernel/kernel”.

-o  Display old-style iostat device statistics. Sectors per second, transfers per second, and milliseconds per seek are displayed. If -I is specified, total blocks/sectors, total transfers, and milliseconds per seek are displayed.

-t  Specify which types of devices to display. There are three different categories of devices:

    device type:
        da  Direct Access devices
        sa  Sequential Access devices
        printer
            Printers
        proc
            Processor devices
        worm
            Write Once Read Multiple devices
        cd  CD devices
        scanner
            Scanner devices
        optical
            Optical Memory devices
        changer
            Medium Changer devices
        comm
            Communication devices
        array
            Storage Array devices
        enclosure
            Enclosure Services devices
        floppy
            Floppy devices

    interface:
        IDE Integrated Drive Electronics devices
        SCSI
            Small Computer System Interface devices
        other
            Any other device interface

    passthrough:
        pass
            Passthrough devices

    The user must specify at least one device type, and may specify at most one device type from each category. Multiple device types in a single device type statement must be separated by commas.

    Any number of -t arguments may be specified on the command line. All -t arguments are ORed together to form a matching expression against which all devices in the system are compared. Any device that fully matches any -t argument will be included in the iostat output, up to the number of devices that can be displayed in 80 columns, or the maximum number of devices specified by the user.

-T  Display TTY statistics. This is on by default, unless -d or -x is specified.

-w  Pause wait seconds between each display. If no wait interval is specified, the default is 1 second.

    The iostat command will accept and honor a non-integer number of seconds. Note that the interval only has millisecond granularity. Finer values will be truncated. E.g., “-w1.0001” is the same as “-w1.000”. The interval will also suffer from modifications to kern.hz so your mileage may vary.

-x  Show extended disk statistics. Each disk is displayed on a line of its own with all available statistics. If this flag is turned on, only disk statistics will be displayed, unless -C or -T is also specified to enable the display of CPU or TTY statistics.

-z  If -x is specified, omit lines for devices with no activity.

-?  Display a usage statement and exit.

The iostat utility displays its information in the following format:

tty
    tin characters read from terminals
    tout
        characters written to terminals

devices
    Device operations. The header of the field is the device name and unit number. The iostat utility will display as many devices as will fit in a standard 80 column screen, or the maximum number of devices in the system, whichever is smaller. If -n is specified on the command line, iostat will display the smaller of the requested number of devices, and the maximum number of devices in the system. To force iostat to display specific drives, their names may be supplied on the command line. The iostat utility will not display more devices than will fit in an 80 column screen, unless the -n argument is given on the command line to specify a maximum number of devices to display. If fewer devices are specified on the command line than will fit in an 80 column screen, iostat will show only the specified devices.

    The standard iostat device display shows the following statistics:

    KB/t
        kilobytes per transfer
    tps transfers per second
    MB/s
        megabytes per second

    The standard iostat device display, with the -I flag specified, shows the following statistics:

    KB/t
        kilobytes per transfer
    xfrs
        total number of transfers
    MB  total number of megabytes transferred

    The extended iostat device display, with the -x flag specified, shows the following statistics:

    r/s read operations per second
    w/s write operations per second
    kr/s
        kilobytes read per second
    kw/s
        kilobytes write per second
    qlen
        transactions queue length
    svc_t
        average duration of transactions, in milliseconds
    %b  % of time the device had one or more outstanding transactions

    The old-style iostat display (using -o) shows the following statistics:

    sps sectors transferred per second
    tps transfers per second
    msps
        average milliseconds per transaction

    The old-style iostat display, with the -I flag specified, shows the following statistics:

    blk total blocks/sectors transferred
    xfr total transfers
    msps
        average milliseconds per transaction

cpu
    us  % of cpu time in user mode
    ni  % of cpu time in user mode running niced processes
    sy  % of cpu time in system mode
    in  % of cpu time in interrupt mode
    id  % of cpu time in idle mode

FILES
/boot/kernel/kernel
    Default kernel namelist.
/dev/kmem
    Default memory file.

EXAMPLES
    iostat -w 1 da0 da1 cd0

Display statistics for the first two Direct Access devices and the first CDROM device every second ad infinitum.

    iostat -c 2

Display the statistics for the first four devices in the system twice, with a one second display interval.

    iostat -t da -t cd -w 1

Display statistics for all CDROM and Direct Access devices every second ad infinitum.

    iostat -t da,scsi,pass -t cd,scsi,pass

Display statistics once for all SCSI passthrough devices that provide access to either Direct Access or CDROM devices.

    iostat -h -n 8 -w 1

Display up to 8 devices with the most I/O every second ad infinitum.

    iostat -dh -t da -w 1

Omit the TTY and CPU displays, show devices in order of performance and show only Direct Access devices every second ad infinitum.

    iostat -Iw 3

Display total statistics every three seconds ad infinitum.

    iostat -odICTw 2 -c 9

Display total statistics using the old-style output format 9 times, with a two second interval between each measurement/display. The -d flag generally disables the TTY and CPU displays, but since the -T and -C flags are given, the TTY and CPU displays will be displayed.

SEE ALSO
fstat(1), netstat(1), nfsstat(1), ps(1), systat(1), devstat(3), gstat(8), pstat(8), vmstat(8)

The sections starting with ``Interpreting system activity'' in

HISTORY
This version of iostat first appeared in FreeBSD 3.0.

AUTHORS
Kenneth Merry <ken@FreeBSD.org>

BUGS
The use of iostat as a debugging tool for crash dumps is probably limited because there is currently no way to get statistics that only cover the time immediately before the crash.